
-- Critical Hits
-- This script was made by THEMUD/137843

local imageTable = {};

math.randomseed(os.time());

function _criticalHit(id, source, weapon, rawdmg)

	local critical_baseMultiplier = 1.5; -- The amount of addition to the critical hit (1.5 = 150%)
	local critical_additionMultiplier = math.random(0, 10) * 0.1; -- The lucky addition to the critical hit in scale of 0 to 10 (from 0% to 100%)
	local critical_damage = math.abs(rawdmg * ((critical_baseMultiplier + critical_additionMultiplier) - (player(id, "armor") * 0.01))); -- The critical hits formula

	if player(id, "health") - (rawdmg + critical_damage) <= 0 then
		parse("effect \"colorsmoke\" "..player(id, "x").." "..player(id, "y").." 10 10 255 0 0");
		parse("sv_soundpos \"themud/critical_hits/hit.wav\" "..player(id, "x").." "..player(id, "y"));
		parse("customkill "..source.." \""..itemtype(weapon, "name").."\" "..id);
	else
		if player(id, "armor") > 0 then -- If a player has armor, the damage of the critical hit will be miniature
			-- Apportion the damage of the critical hit on both health and armor (60% on the health and 40% on the armor)
			parse("sethealth "..id.." "..player(id, "health") - ((rawdmg + critical_damage) * 0.6));
			parse("setarmor "..id.." "..player(id, "armor") - ((rawdmg + critical_damage) * 0.4));
			parse("sv_soundpos \"themud/critical_hits/hit.wav\" "..player(id, "x").." "..player(id, "y"));
			parse("effect \"colorsmoke\" "..player(id, "x").." "..player(id, "y").." 10 10 255 0 0");
		else
			parse("sethealth "..id.." "..player(id, "health") - (rawdmg + critical_damage));
			parse("sv_soundpos \"themud/critical_hits/hit.wav\" "..player(id, "x").." "..player(id, "y"));
			parse("effect \"colorsmoke\" "..player(id, "x").." "..player(id, "y").." 10 10 255 0 0");
		end

		-- Display the blood image on the player's screen, rescale it and change its alpha during 1 second
		imageTable[id] = image("gfx/themud/critical_hits/blood.png", 0, 1, id+132, id);
		imagealpha(imageTable[id], 1);
		imagescale(imageTable[id], 1.5, 1.1);
		tween_alpha(imageTable[id], 1000, 0);
	end
end

function _leave(id)
	if imageTable[id] then
		freeimage(imageTable[id]);
		imageTable[id] = nil;
	end
end

function _die(id)
	if imageTable[id] then
		freeimage(imageTable[id]);
		imageTable[id] = nil;
	end
end

function _hit(id, source, weapon, hpdmg, apdmg, rawdmg)

	local luck = math.random(0, 10); -- How often will the critical hit occur

	if luck == 3 then -- If you are fortuitous. Basically, if math.random generates a number that is 3, then the critical hit will occur
		if tonumber(game("sv_gamemode")) ~= 1 then -- Checks if the gamemode is not Deathmath
			if player(source, "team") == player(id, "team") then -- So that players in the same team can't hit each other
				return 1;
			else -- But players in different teams can
				_criticalHit(id, source, weapon, rawdmg);
				return 1;
			end
		else -- If the gamemode is Deathmatch, then everyone can hit everyone and so the critical hits apply on everyone
			_criticalHit(id, source, weapon, rawdmg);
			return 1;
		end
	else -- If the luck was not with you, proceed the normal hit
		return 0;
	end
end

addhook("leave", "_leave")
addhook("die", "_die")
addhook("hit", "_hit")